#!/usr/bin/ruby
# -*- coding: utf-8 -*-

#------ 診療行為内容取得


require 'uri'
require 'net/http'

Net::HTTP.version_1_2

HOST = "localhost"
PORT = "8000"
USER = "ormaster"
PASSWD = "ormaster"
CONTENT_TYPE = "application/xml"


req = Net::HTTP::Post.new("/api01rv2/medicalgetv2?class=03")
# class :01 受診履歴取得
# class :02 日別診療情報取得
# class :03 月別診療情報取得
# class :04 区分別剤点数情報取得
#
#        入外区分          InOut                           (IMPLIED)
#        患者番号          Patient_ID                      (REQUIRED)
#        診療年月日        Perform_Date                    (IMPLIED)
#        月数              For_Months                      (IMPLIED)
#        診療科コード      Department_Code                 (REQUIRED)
#        連番              Sequential_Number               (IMPLIED)
#        保険組合せ番号    Insurance_Combination_Number    (IMPLIED)
#        保険の種類        InsuranceProvider_Class         (IMPLIED)
#        保険の制度名称    InsuranceProvider_WholeName     (IMPLIED)
#        保険者番号        InsuranceProvider_Number        (IMPLIED)
#        公費の種類        PublicInsurance_Class           (IMPLIED)
#        公費の制度名称    PublicInsurance_Name            (IMPLIED)
#        負担者番号        PublicInsurer_Number            (IMPLIED)
#        受給者番号        PublicInsuredPerson_Number      (IMPLIED)
#
#        REQUIRED : 必須   IMPLIED : 任意
#
BODY = <<EOF
<data>
	<medicalgetreq type="record">
		<InOut type="string">I</InOut>
		<Patient_ID type="string">2</Patient_ID>
		<Perform_Date type="string">2012-06-12</Perform_Date>
		<For_Months type="string">12</For_Months>
		<Medical_Information type="record">
			<Department_Code type="string">02</Department_Code>
			<Sequential_Number type="string">1</Sequential_Number>
			<Insurance_Combination_Number type="string">0015</Insurance_Combination_Number>
			<HealthInsurance_Information type="record">
				<InsuranceProvider_Class type="string">009</InsuranceProvider_Class>
				<InsuranceProvider_WholeName type="string">協会</InsuranceProvider_WholeName>
				<InsuranceProvider_Number type="string"> </InsuranceProvider_Number>
				<HealthInsuredPerson_Symbol type="string"> </HealthInsuredPerson_Symbol>
				<HealthInsuredPerson_Number type="string"> </HealthInsuredPerson_Number>
				<PublicInsurance_Information type="array">
					<PublicInsurance_Information_child type="record">
						<PublicInsurance_Class type="string">051</PublicInsurance_Class>
						<PublicInsurance_Name type="string"></PublicInsurance_Name>
						<PublicInsurer_Number type="string">51020001</PublicInsurer_Number>
						<PublicInsuredPerson_Number type="string"></PublicInsuredPerson_Number>
					</PublicInsurance_Information_child>
				</PublicInsurance_Information>
			</HealthInsurance_Information>
		</Medical_Information>
	</medicalgetreq>
</data>
EOF


req.content_length = BODY.size
req.content_type = CONTENT_TYPE
req.body = BODY
req.basic_auth(USER, PASSWD)
  puts req.body

Net::HTTP.start(HOST, PORT) {|http|
  res = http.request(req)
  puts res.body
}

